/************************************************************************/
/*																		*/
/*	Dclock.h	--	Interface Declarations for PIC32 Clock Generation	*/
/*																		*/
/************************************************************************/
/*	Author:		Oliver Jones											*/
/*	Copyright 2011, Digilent Inc.										*/
/************************************************************************/
/*  File Description:													*/
/*																		*/
/*																		*/
/************************************************************************/
/*  Revision History:													*/
/*																		*/
/*	07/19/2011(OliverJ): created										*/
/*																		*/
/************************************************************************/


#if !defined(DCLOCK_INC)
#define DCLOCK_INC

/* ------------------------------------------------------------ */
/*					Miscellaneous Declarations					*/
/* ------------------------------------------------------------ */

#define crystalFrq 8000000

/* ------------------------------------------------------------ */
/*					General Type Declarations					*/
/* ------------------------------------------------------------ */

//Bit Masks for system clock
#define bmPLLODIV	0x38000000
#define bmFRCDIV	0x07000000
#define bmPLLMULT	0x00070000

//Bit Mask for peripheral bus clock
#define bmPBDIV		0x00180000

#define pllDiv256	0x38000000
#define pllDiv64	0x30000000
#define pllDiv32	0x28000000
#define pllDiv16	0x20000000
#define pllDiv8		0x18000000
#define pllDiv4		0x10000000
#define pllDiv2		0x08000000
#define pllDiv1		0x00000000

#define frcDiv256	0x07000000
#define frcDiv64	0x06000000
#define frcDiv32	0x05000000
#define frcDiv16	0x04000000
#define frcDiv8		0x03000000
#define frcDiv4		0x02000000
#define frcDiv2		0x01000000
#define	frcDiv1		0x00000000

#define pllMult24	0x00070000
#define pllMult21	0x00060000
#define pllMult20	0x00050000
#define pllMult19	0x00040000
#define pllMult18	0x00030000
#define pllMult17	0x00020000
#define pllMult16	0x00010000
#define pllMult15	0x00000000

#define pbDiv8		0x00180000
#define pbDiv4		0x00100000
#define pbDiv2		0x00080000
#define pbDiv1		0x00000000
 
unsigned int DclockGetSysClock();
unsigned int DclockGetPbClock();

#endif
